﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using SQLiteDatabase.Database;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkID=390556

namespace SQLiteDatabase
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class Display : Page
    {
        public Display()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.
        /// This parameter is typically used to configure the page.</param>

        private ObservableCollection<Schema.Students> Mylist; 

        protected async override void OnNavigatedTo(NavigationEventArgs e)
        {
            //Set the item Source if database exists
            bool check = await Database.DatabaseHelper.Checkdatabase();
            if (check)
            {
                Mylist = Database.DatabaseHelper.GetAllStudents();
                MylistView.ItemsSource = Mylist;
            }
        }

        private void Delete_Button_Click(object sender, RoutedEventArgs e)
        {
            var myobject = (sender as Button).DataContext as Schema.Students;

            //Delete the item
            Database.DatabaseHelper.DeleteStudent(myobject.Id);
            Mylist.Remove(myobject);

        }
    }
}
